#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>
#include "types.h"
#include "defaults.h"
#include "mystring.h"
#include "warning.h"
#include "pin.h"
#include "X.h"
#include "pixmap.h"
#include "window.h"
#include "keyboard.h"
#include "hash.h"
#include "loop.h"
#include "pol.h"
#include "bindings.h"
#include "input.h"
#include "output.h"
#include "color.h"
#include "edit.h"
#include "popup.h"
#include "languages.h"
#include "save.h"
#include "load.h"
#include "home.h"
#include "widget.h"
#include "map.h"
#include "post.h"
#include "timer.h"
#include "predmet.h"
#include "misc.h"

void kql_init (int argc, char **argv)
{
  struct stat buf;

  gargc = argc;
  gargv = argv;
  srand(time(0));
  inithome();
  if(setlocale(LC_ALL,"") == NULL) warning("could not set default locale");
  if(stat(DATADIR_LOCAL, &buf) == 0) DATADIR = DATADIR_LOCAL;
  initX();
  pinnull.typ = PINNULL;
  inithash();
  initbindings();
  init_sl();
}

void kql_start (void (*r_func)())
{
  char *fullname;
  struct stat buf;

  restart_func = r_func;

  printf("This is kraluk version 0.7.1\n");

  dokoncipol();
  if(r_func) r_func();
  finishws();

  nactijazyky();
  aktulang = prvlang;
  load_conf();
  startlang();

  if(SAVELAST){
    fullname = joinstrings(homedir, "/", SAVELAST, NULL);
    if(stat(fullname, &buf) == 0) load_all(SAVELAST);
    free(fullname);
  }

  if(!win){
    prvnipol();
    popup_info("_about");
  }
  initklav();
  loop();
}

void kql_restart ()
{
  if(!restart_func) return;

  autoreloadmap = 0;

  deleteApixmaps();
  deleteAwidgets();
  deleteAsubmaps();
  deleteAanips();
  deleteAposts();
  deleteAtimers();
  deleteApredmets();
  aktulslovo = prvulslovo;

  restart_func();

  vykreslipol();
}

void kql_exit ()
{
  if(SAVELAST) save_all(SAVELAST);
  save_conf();
  XUnloadFont(display, font_info->fid);
  XUnloadFont(display, popup_small_font->fid);
  if(popup_big_font != popup_small_font)
    XUnloadFont(display, popup_big_font->fid);
  XFreeGC(display, text_gc);
  XCloseDisplay(display);
  exit(0);
}
