#include<stdio.h>
#include<stdlib.h>
#include "types.h"
#include "X.h"
#include "defaults.h"
#include "pixmap.h"
#include "window.h"
#include "widget.h"

kq_widget *prvwidget = NULL;
kq_widget *poshidwid = NULL;

static void prohodwid (kq_widget *wid1)
    // Prohodi wid1 s dalsim widgetem.
/*******************************************/
{
  kq_widget *pom1, *pom2, *wid2;

  // Dosadim pomocne promenne:

  wid2 = wid1->next;
  if(!wid2){
    printf("nemuzu prohodit posledni widget\n");
    return;
  }
  pom1 = wid1->prev;
  pom2 = wid2->next;

  /*
    Nyni mam takoveto widgety: pom1 -> wid1 -> wid2 -> pom2,
    pricemz cil je je usporadat takto: pom1 -> wid2 -> wid1 -> pom2.
  */

  // Vyresim kraje:

  if(wid1==prvwidget) prvwidget = wid2;
  if(wid2==poshidwid) poshidwid = wid1;

  // Spojim pom1 a wid2:

  if(pom1) pom1->next = wid2;
  wid2->prev = pom1;

  // Spojim pom2 a wid1:

  if(pom2) pom2->prev = wid1;
  wid1->next = pom2;

  // Spojim wid1 a wid2 ze spravne strany:

  wid2->next = wid1;
  wid1->prev = wid2;

  // Nyni mam widgety ve spravnem poradi a jeste je prohodim graficky:

  if(wid1->hide || !wid1->obr || !wid2->obr || !win)
    return;

  Window wpole[2];

  wpole[0] = wid2->okno;
  wpole[1] = wid1->okno;
  XRestackWindows(display, wpole, 2);

  mengraf=1;  // Zmenila se grafika
}

static void prestackujd (kq_widget *w)
    // Posune widget v seznamu doprava, aby byl spravne umisten se svou z souradnici.
/******************************************/
{
  while(w->next && w->next->z > w->z) prohodwid(w);
}

static void prestackujn (kq_widget *w)
    // Posune widget v seznamu doleva, aby byl spravne umisten se svou z souradnici.
/******************************************/
{
  while(w->prev && w->prev->z < w->z) prohodwid(w->prev);
}

static void zobrazwidget(kq_widget *w)
{
  if(!win){
    w->prev = poshidwid;
    w->next = NULL;
    if(poshidwid) poshidwid->next = w;
    poshidwid = w;
    prestackujn(w);

    return;
  }

  if(w->obr){

    // Je-li treba, prescaluji pixmapu:

    if(w->obr->scaled != ratio){
      rescalePixmap(w->obr->ibarvy, &w->obr->barvy);
      rescalePixmap(w->obr->ikanal, &w->obr->akanal);
      w->obr->scaled = ratio;
    }

    // Vykreslim widget:

    w->okno = XCreateSimpleWindow(display, win, w->x*ratio, w->y*ratio,
				  w->obr->PIX_SIR*ratio,
				  w->obr->PIX_VYS*ratio, 0,
				  BlackPixel(display,screen),
				  WhitePixel(display,screen));

    XShapeCombineMask (display, w->okno, ShapeBounding,
		       0, 0, w->obr->akanal, ShapeSet);

    XSetWindowBackgroundPixmap(display, w->okno, w->obr->barvy);

    XMapWindow(display, w->okno);

    mengraf = 1; // Zmenila se grafika
  }

  // Zaradim ho mezi ostatni widgety:

  w->next = prvwidget;
  w->prev = NULL;
  if(prvwidget) prvwidget->prev = w;
  prvwidget = w;
  prestackujd(w);
}

void zmenratio (int oco)
{
  if(oco > 0){
    if(ratio + oco > MAXRATIO) oco = MAXRATIO-ratio;
    if(oco < 0) oco = 0;
  }
  if(oco < 0){
    if(ratio + oco < MINRATIO) oco = MINRATIO-ratio;
    if(oco > 0) oco = 0;
  }
  if(oco){
    printf("RATIO: %d:1\n", ratio+oco);
    rescale(ratio+oco);
  }
}

void rescale (int newrat) // prescaluje hru
/**********************/
{
  kq_widget *pom;

  if(ratio == newrat) return;
  ratio = newrat;   // dosadim nove ratio

  rescaleokno(); // Prescaluji okno 

  for(pom = prvwidget; pom; pom = pom->next){ // Prescaluji kazdy widget:
    if(pom->obr){

      // Prescaluji pixmapy:

      rescalePixmap(pom->obr->ibarvy, &(pom->obr->barvy));
      rescalePixmap(pom->obr->ikanal, &(pom->obr->akanal));
      pom->obr->scaled = ratio;

      // Upravim velikost a umisteni widgetu.

      XMoveResizeWindow(display, pom->okno,
			pom->x*ratio, pom->y*ratio,
			pom->obr->PIX_SIR*ratio, pom->obr->PIX_VYS*ratio);

      // Nastavim novou pixmapu:

      XSetWindowBackgroundPixmap(display, pom->okno, pom->obr->barvy);
      XShapeCombineMask (display, pom->okno, ShapeBounding,
		       0, 0, pom->obr->akanal, ShapeSet);
      XCopyArea(display, pom->obr->barvy, pom->okno, ggc,
		0, 0,
		pom->obr->PIX_SIR*ratio, pom->obr->PIX_VYS*ratio,
		0, 0);
    }
  }
}

kq_widget *vytvorwidget (int x, int y, float z, kq_pixmap *obrazek,
				char lokalni, char hide)
/******************************************************************/
{
  kq_widget *vysledek;

  vysledek = (kq_widget *)malloc(sizeof(kq_widget));

  // Dosadim zadane parametry:

  vysledek->x = x;
  vysledek->y = y;
  vysledek->z = z;
  vysledek->obr = obrazek;
  vysledek->lokalni = lokalni;
  vysledek->hide = hide;

  if(hide){
    vysledek->prev = poshidwid;
    vysledek->next = NULL;
    if(poshidwid) poshidwid->next = vysledek;
    poshidwid = vysledek;
    prestackujn(vysledek);
  }
  else zobrazwidget(vysledek);

  return vysledek;
}

void ukazwidgety ()
{
  kq_widget *pom, *pomo;

  for(pom = poshidwid; pom; pom = pomo){
    pomo = pom->prev;

    if(pom->hide <= 0){
      pom->hide = 0;
      if(pom->next) pom->next->prev = pom->prev;
      if(pomo) pomo->next = pom->next;
      if(poshidwid == pom) poshidwid = pomo;

      zobrazwidget(pom);
    }
  }
}

void posunwidget (kq_widget *w, int x, int y)
/*************************************************/
{
  if(w->x != x || w->y != y){
    w->x = x;
    w->y = y;
    if(w->hide || !w->obr) return;
    XMoveWindow(display, w->okno, x*ratio,y*ratio);
    mengraf = 1;
  }
}

void prebarviwidget (kq_widget *w, kq_pixmap *obrazek)
/**************************************************************/
{
  if(w->obr == obrazek) return;
  if(w->hide){
    w->obr = obrazek;
    return;
  }
  if(obrazek == NULL){
    XDestroyWindow(display, w->okno);
    mengraf = 1;
    w->obr = NULL;
    return;
  }
  if(w->obr == NULL){
    w->obr = obrazek;
    if(w->prev) w->prev->next = w->next;
    if(w->next) w->next->prev = w->prev;
    if(prvwidget == w) prvwidget = w->next;
    if(poshidwid == w) poshidwid = w->prev;
    zobrazwidget(w);
    return;
  }

  // Je-li treba, prescaluji pixmapu:

  if(obrazek->scaled != ratio){
    rescalePixmap(obrazek->ibarvy, &obrazek->barvy);
    rescalePixmap(obrazek->ikanal, &obrazek->akanal);
    obrazek->scaled = ratio;
  }

  // Zmenim velikost okna pro novou pixmapu:

  if(w->obr->PIX_VYS != obrazek->PIX_VYS || w->obr->PIX_SIR != obrazek->PIX_SIR)
    XResizeWindow(display, w->okno, obrazek->PIX_SIR*ratio,
		  obrazek->PIX_VYS*ratio);

  // Nastavim pixmapu:

  w->obr = obrazek;

  XSetWindowBackgroundPixmap(display, w->okno, obrazek->barvy);
  XShapeCombineMask (display, w->okno, ShapeBounding,
		     0, 0, obrazek->akanal, ShapeSet);

  XCopyArea(display, obrazek->barvy, w->okno, ggc,
	    0, 0,
	    obrazek->PIX_SIR*ratio, obrazek->PIX_VYS*ratio,
	    0, 0);

  mengraf = 1; // Zmenila se grafika
}

void posunzwidget (kq_widget *w, float z) // Zmeni z-ovou souradnici
/*******************************************/
{
  if(w->z == z) return;

  if(w->z > z){
    w->z = z;
    prestackujd(w);
  }
  else if(w->z < z){
    w->z = z;
    prestackujn(w);
  }
}

void zmenwidget (kq_widget *w, int x, int y, float z, kq_pixmap *obrazek)
/******************************************************************************/
{
  posunzwidget(w, z) ;
  posunwidget(w, x, y);
  prebarviwidget(w, obrazek);
}

void znicwidget (kq_widget *w)
/**********************************/
{
  if(w->next) w->next->prev = w->prev;
  else if(w->hide) poshidwid = w->prev;

  if(w->prev) w->prev->next = w->next;
  else if(!w->hide) prvwidget = w->next;

  if(!w->hide && w->obr){
    XDestroyWindow(display, w->okno);
    mengraf = 1;
  }

  free(w);
}

void hidewidget(kq_widget *w)
{
  if(w->hide) return;
  w->hide = 1;

  if(w->next) w->next->prev = w->prev;
  if(w->prev) w->prev->next = w->next;
  if(w == prvwidget) prvwidget = w->next;
  if(w->obr){
    XDestroyWindow(display, w->okno);
    mengraf = 1;
  }

  w->prev = poshidwid;
  w->next = NULL;
  if(poshidwid) poshidwid->next = w;
  poshidwid = w;
  prestackujn(w);
}

void unhidewidget(kq_widget *w)
{
  if(!w->hide) return;
  w->hide = 0;

  if(w->next) w->next->prev = w->prev;
  if(w->prev) w->prev->next = w->next;
  if(w == poshidwid) poshidwid = w->prev;

  zobrazwidget(w);
}

void deletelwidgets ()  // smaze lokalni widgety (pri prechodu na jine policko)
/********************/
{
  /*
    Promennou pomo vzdy naleznu nejblizsi nelokalni widget, pricemz
    mazu widgety za ni. Pak to propojim s predchozim nelokalnim widgetem
    pomoci pom.
  */

  kq_widget **pom;
  kq_widget *pomo;
  kq_widget *pomoc;

  for(pom = &poshidwid;;){
    for(pomo = *pom; pomo && pomo->lokalni > 0; pomo = pomoc){
      pomoc = pomo->prev;
      free(pomo);
    }

    if(!pomo) break;

    pomo->next = (*pom)->next;
    *pom = pomo;

    pom = &(pomo->prev);
  }
  *pom = NULL;

  for(pom = &prvwidget;; pom = &(pomo->next)){
    for(pomo = *pom; pomo && pomo->lokalni; pomo = pomoc){
      pomoc = pomo->next;
      if(pomo->obr) XDestroyWindow(display, pomo->okno);
      mengraf = 1;
      if(pomo->lokalni > 0) free(pomo);
      else{
	pomo->hide = 1;
	pomo->prev = poshidwid;
	pomo->next = NULL;
	if(poshidwid) poshidwid->next = pomo;
	poshidwid = pomo;
	prestackujn(pomo);
      }
    }

    if(!pomo) break;

    pomo->prev = (*pom)->prev;
    *pom = pomo;
  }
  *pom = NULL;
}

void deleteAwidgets()
{
  kq_widget *pom;

  while(prvwidget){
    pom = prvwidget->next;
    if(prvwidget->obr) XDestroyWindow(display, prvwidget->okno);
    free(prvwidget);
    prvwidget = pom;
  }
  while(poshidwid){
    pom = poshidwid->prev;
    free(poshidwid);
    poshidwid = pom;
  }
}

void vypiswidget(kq_widget *w)
{
  if(w == NULL){
    printf("NULL\n");
    return;
  }

  if(w->lokalni == 0) printf("global ");
  if(w->lokalni > 0) printf("local ");

  printf("widget, obr=");
  if(w->obr == NULL) printf("NULL");
  else printf("\"%s\"", w->obr->nazev);
  printf(", x=%d, y=%d, z=%f", w->x,w->y,w->z);
  if(w->hide) printf("\tHIDEN");
  printf("\n");
}

void vypiswidgety()
{
  kq_widget *pom;

  printf("schovane widgety:\n");
  for(pom=poshidwid; pom; pom = pom->prev){
    printf("  ");
    vypiswidget(pom);
  }
  printf("zobrazene widgety:\n");
  for(pom=prvwidget; pom; pom = pom->next){
    printf("  ");
    vypiswidget(pom);
  }
  printf("\n");
}
